package com.xjgs.service;

import com.xjgs.dao.JDBCUtils;
import com.xjgs.dao.JDBCUtils1;
import com.xjgs.dao.JDBCUtils3;
import com.xjgs.dao.JDBCUtils5;
import com.xjgs.util.Logger;
import com.xjgs.util.MD5;
import com.xjgs.util.Base64;
import com.xjgs.vo.*;
import oracle.sql.BLOB;
import org.apache.commons.io.FileUtils;
import org.apache.commons.lang3.StringUtils;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import org.junit.Test;

import java.io.*;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.*;

public class HisService {
    private static Logger logger = new Logger();

    public List<V_emrpatient> getPatientInfo() {
        String sql = "select fpatno as 记账号,fpatfileno as 住院号,fpattimes as 住院次数,fpatname as 姓名,farchieve_dt as 最后更改时间 from pacs.V_emrpatient t \n" +
                "where FARCHIEVE_DT between sysdate-6/1 and sysdate order by farchieve_dt ASC";
        List<V_emrpatient> v_emrpatients = new ArrayList<V_emrpatient>();
        V_emrpatient v_emrpatient = null;
        ResultSet resultSet = null;
        Connection connection = null;
        PreparedStatement statement = null;
        try {
            connection = JDBCUtils.getConnection();
            statement = connection.prepareStatement(sql);
            resultSet = statement.executeQuery();
            while (resultSet.next()) {
                v_emrpatient = new V_emrpatient();
                v_emrpatient.setFpatno(resultSet.getString("记账号"));
                v_emrpatient.setFarchieve_dt(resultSet.getString("最后更改时间"));
                v_emrpatients.add(v_emrpatient);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            JDBCUtils.release(resultSet, statement, connection);
        }
        return v_emrpatients;
    }

    //电子病历采集
    public void hisInfo() {
        SimpleDateFormat dateFormat1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String format = dateFormat1.format(new Date());
        List<V_emrpatient> patientInfo = getPatientInfo();
        logger.log("电子病历与护理已开始采集，需要同步" + patientInfo.size() + "份病历");
        for (V_emrpatient v_emrpatient : patientInfo) {
            ArchiveMaster masterIdByPa = getMasterIdByPa(v_emrpatient.getFpatno());
            if (null != masterIdByPa.getId()) {
                List<Archive_Detail> pdfPathByIdAndHis = getPdfPathByIdAndHis(masterIdByPa);
                for (Archive_Detail archiveDetail : pdfPathByIdAndHis) {
                    File file = new File(archiveDetail.getPdfPath().replace("F:\\pdf", "Z:"));
                    if (file.exists()) {
                        file.delete();
                    }
                }
                redirectHisInfo(masterIdByPa);
                hisInfnByPatientId(v_emrpatient.getFpatno());
            } else {
                uploadHomePageByPid(v_emrpatient.getFpatno());
                hisInfnByPatientId(v_emrpatient.getFpatno());
            }
        }
        String format1 = dateFormat1.format(new Date());
        logger.log("电子病历与护理已采集，采集时间,开始时间:" + format + "结束时间:" + format1 + ",共同步" + patientInfo.size() + "份病历");
    }


    //电子病历采集
    public void hisInfnByPatientId(String PatientId) {
        SimpleDateFormat dateFormat1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String format = dateFormat1.format(new Date());
        uploadHisInfo(PatientId);
        uploadEmrInfo(PatientId);
        String format1 = dateFormat1.format(new Date());
        logger.log("电子病历与护理已采集，采集时间,开始时间:" + format + "结束时间:" + format1 + "," + PatientId + "病历已补偿完成");
    }


    //护理采集
//    @Test
//    public void hisInfo1(){
//        List<ArchiveMaster> masterList = hisInfoMasterId();
//        for(ArchiveMaster archiveMaster:masterList){
//            uploadEmrInfo(archiveMaster.getPatientId());
//        }
//    }
    public List<ArchiveMaster> hisInfoMasterId() {
        List<V_emrpatient> patientInfo = getPatientInfo();
        logger.log("电子病历与护理已采集，需要同步" + patientInfo.size() + "份病历");
        List<ArchiveMaster> archiveMasterList = new ArrayList<>();
        for (V_emrpatient v_emrpatient : patientInfo) {
            ArchiveMaster masterIdByPa = getMasterIdByPa(v_emrpatient.getFpatno());
            if (null != masterIdByPa.getId()) {
                List<Archive_Detail> pdfPathByIdAndHis = getPdfPathByIdAndHis(masterIdByPa);
                for (Archive_Detail archiveDetail : pdfPathByIdAndHis) {
                    File file = new File(archiveDetail.getPdfPath().replace("F:\\pdf", "Z:"));
                    if (file.exists()) {
                        file.delete();
                    }
                }
                redirectHisInfo(masterIdByPa);
                archiveMasterList.add(masterIdByPa);
            } else {
                uploadHomePageByPid(v_emrpatient.getFpatno());
                ArchiveMaster archiveMaster = getMasterIdByPa(v_emrpatient.getFpatno());
                archiveMasterList.add(archiveMaster);
            }
        }
        return archiveMasterList;
    }

    public void uploadHomePageByPid(String patientId) {
        String sql = "select  t.zyh as 住院号,t.jzh as 记账号,t.zycs as 住院次数,t.xm as 姓名,t.xb as 性别,t.ryrq as 入院日期,t.cyrq as 出院日期,t.sfzh as 身份证号,t.rybq as 入院科室,t.dqbq as 出院科室,t.rycw as 入院床位,hp.fdrname as 主管医生 " +
                "from ndns.zl t left join hthis.p_doctor hp on t.dqys = hp.fdrid where t.jzh = ? order by t.jzh desc";
        ArchiveMaster master = null;
        ResultSet resultSet = null;
        Connection connection = null;
        PreparedStatement statement = null;
        Object[] parms = new Object[]{patientId};
        try {
            connection = JDBCUtils.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            resultSet = statement.executeQuery();
            while (resultSet.next()) {
                master = new ArchiveMaster();
                master.setInpNo(resultSet.getString("住院号").trim());
                master.setPatientId(resultSet.getString("记账号").trim());
                master.setVisitId(resultSet.getString("住院次数"));
                master.setName(resultSet.getString("姓名"));
                master.setSex(resultSet.getString("性别"));
                master.setAdmissionDateTime(resultSet.getString("入院日期"));
                master.setDischargeDateTime(resultSet.getString("出院日期"));
                master.setIdNo(resultSet.getString("身份证号"));
                master.setDeptAdmissionTo(resultSet.getString("入院科室"));
                master.setDeptName(resultSet.getString("出院科室"));
                master.setDoctorInCharge(resultSet.getString("主管医生"));
                master.setBedId(resultSet.getString("入院床位"));
                master.setSource("hisOneDay");
                if (!StringUtils.isNoneBlank(master.getDischargeDateTime())) {
                    master.setStatus("在院");
                } else {
                    master.setStatus("归档中");
                }
                if ("2".equals(master.getSex())) {
                    master.setSex("女");
                } else {
                    master.setSex("男");
                }
                writeHomeEntity(master);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            JDBCUtils.release(resultSet, statement, connection);
        }
    }


    int writeHomeEntity(ArchiveMaster archiveMaster) {
        String sql = "insert into archive_master(id,patient_id,inp_no,visit_id,name,sex,dept_name,discharge_date_time," +
                "archivestate,admission_date_time,dept_admission_to,doctor_in_charge,id_no,bed_id,source)values(replace(newid(), '-', ''),?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
        Object[] parms = new Object[]{archiveMaster.getPatientId(), archiveMaster.getInpNo(), archiveMaster.getVisitId(), archiveMaster.getName(), archiveMaster.getSex(), archiveMaster.getDeptName(), archiveMaster.getDischargeDateTime(), archiveMaster.getStatus(), archiveMaster.getAdmissionDateTime(), archiveMaster.getDeptAdmissionTo(), archiveMaster.getDoctorInCharge(), archiveMaster.getIdNo(), archiveMaster.getBedId(),archiveMaster.getSource()};
        Connection connection = null;
        PreparedStatement statement = null;
        int j = 0;
        try {
            connection = JDBCUtils3.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            j = statement.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            JDBCUtils.release(null, statement, connection);
        }
        return j;
    }

    public List<Archive_Detail> getPdfPathByIdAndHis(ArchiveMaster archiveMaster) {
        String sql = "select id,PDF_PATH from archive_detail where Source='his' and MasterID=?";
        Object[] parms = new Object[]{archiveMaster.getId()};
        Connection connection = null;
        PreparedStatement statement = null;
        ResultSet resultSet = null;
        List<Archive_Detail> archive_details = new ArrayList<>();
        Archive_Detail archiveDetail = null;
        try {
            connection = JDBCUtils3.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            resultSet = statement.executeQuery();
            while (resultSet.next()) {
                archiveDetail = new Archive_Detail();
                archiveDetail.setId(resultSet.getString("id"));
                archiveDetail.setPdfPath(resultSet.getString("PDF_PATH"));
                archive_details.add(archiveDetail);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            JDBCUtils.release(resultSet, statement, connection);
        }
        return archive_details;
    }

    public int redirectHisInfo(ArchiveMaster archiveMaster) {
        String sql = "delete from archive_detail where MasterID = ? and Source = 'his'";
        Object[] parms = new Object[]{archiveMaster.getId()};
        int j = 0;
        Connection connection = null;
        PreparedStatement statement = null;
        try {
            connection = JDBCUtils3.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            j = statement.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            JDBCUtils.release(null, statement, connection);
        }
        return j;
    }

    public ArchiveMaster getMasterIdByPa(String jzh) {
        String sql = "select ID,patient_id from archive_master where patient_id = ?";
        Object[] parms = new Object[]{jzh};
        ArchiveMaster archiveMaster = null;
        ResultSet resultSet = null;
        Connection connection = null;
        PreparedStatement statement = null;
        try {
            connection = JDBCUtils3.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            resultSet = statement.executeQuery();
            while (resultSet.next()) {
                archiveMaster = new ArchiveMaster();
                archiveMaster.setId(resultSet.getString("ID"));
                archiveMaster.setPatientId(resultSet.getString("patient_id"));
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            JDBCUtils.release(resultSet, statement, connection);
        }
        return archiveMaster == null ? new ArchiveMaster() : archiveMaster;
    }

    //取his数据
    public void uploadHisInfo(String patientId) {
        String temp = System.getProperty("user.dir") + "\\temp";
        File fs = new File(temp);
        if (!fs.isDirectory()) {
            fs.mkdirs();
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String format = sdf.format(new Date());
        ResultSet resultSet = null;
        Connection connection = null;
        PreparedStatement statement = null;
        FileOutputStream file = null;
        InputStream in = null;
        try {
            connection = JDBCUtils.getConnection();
            String sql = "select FFILE_ID,FPATNO as 记账号,fpattimes as 住院次数,FPATFILENO AS 住院号,FPATNAME AS 姓名,\n" +
                    "FENTRY_NO as 病例分类ID,FFILE_CONTENT AS 文件内容,FLOGLUDATE AS 最后修改时间,FREC_NAME AS 记录名称 from V_EMRPDFFILE \n" +
                    "where  dbms_lob.getlength(FFILE_CONTENT)!=0 and FPATNO = ? order by frec_dt";
            Object[] parms = new Object[]{patientId};
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            resultSet = statement.executeQuery();
            Archive_Detail archiveDetail = null;
            while (resultSet.next()) {
                archiveDetail = new Archive_Detail();
                archiveDetail.setSubAssort(resultSet.getString("FFILE_ID"));
                String visit_id = resultSet.getString("住院次数");
                archiveDetail.setMasterId(getMasterIdByPa(resultSet.getString("记账号")).getId());
                archiveDetail.setTitle(resultSet.getString("记录名称"));
                BLOB blob = (BLOB) resultSet.getBlob("文件内容");
                in = blob.getBinaryStream(); // 建立输出流
                UUID uuid = UUID.randomUUID();//UUID唯一识别
                String id = uuid.toString();
                id = id.replace("-", "");
                file = new FileOutputStream(temp + "\\" + id + ".pdf");
                int len = (int) blob.length();
                byte[] buffer = new byte[len]; // 建立缓冲区
                while ((len = in.read(buffer)) != -1) {
                    file.write(buffer, 0, len);
                }
                archiveDetail.setPdfPath(getXmlPath("path") + "\\his\\" + resultSet.getString("记账号") + "\\" + id + ".pdf");
                File file1 = new File(getXmlPath("path") + "\\his\\" + resultSet.getString("记账号"));
                if (!file1.isDirectory()) {
                    file1.mkdirs();
                }
                if (null != in) {
                    in.close();
                }
                if (null != file) {
                    file.close();
                }
                if (new File(temp + "\\" + id + ".pdf").exists()) {
                    FileUtils.copyFile(new File(temp + "\\" + id + ".pdf"), new File(archiveDetail.getPdfPath()));
                }
                archiveDetail.setAssortId(getEmrAssort(resultSet.getString("病例分类ID")));
                archiveDetail.setFlag("0");
                archiveDetail.setSource("his");
                archiveDetail.setUploadDateTime(new Date());
                File file2 = new File(archiveDetail.getPdfPath());
                if (file2.exists()) {
                    archiveDetail.setPdfPath(archiveDetail.getPdfPath().replace("Z:", "F:\\pdf"));
                    writeArchiveDetail(archiveDetail);
                }
                File file3 = new File(temp + "\\" + id + ".pdf");
                file3.delete();
            }
            logger.log("电子病历已采集,时间" + format + ",记账号:" + patientId);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (null != in) {
                    in.close();
                }
                if (null != file) {
                    file.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            } finally {
                JDBCUtils.release(resultSet, statement, connection);
            }
        }
    }

    public void uploadEmrInfo(String patientId) {
        String temp = System.getProperty("user.dir") + "\\temp";
        File fs = new File(temp);
        if (!fs.isDirectory()) {
            fs.mkdirs();
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String format = sdf.format(new Date());
        ResultSet resultSet = null;
        Connection connection = null;
        PreparedStatement statement = null;
        FileOutputStream file = null;
        InputStream in = null;
        try {
            connection = JDBCUtils1.getConnection();
            String sql = "select FFILE_ID,FPATNO as 记账号,fpattimes as 住院次数,FPATFILENO AS 住院号,FPATNAME AS 姓名,FFILE_CONTENT AS 文件内容,FLOGLUDATE AS 最后修改时间,FREC_NAME AS 记录名称\n" +
                    "from V_EMRPDFFILE_NURSE where dbms_lob.getlength(FFILE_CONTENT)!=0 and FPATNO=? \n" +
                    "order by FLOGLUDATE";
            Object[] parms = new Object[]{patientId};
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            resultSet = statement.executeQuery();
            Archive_Detail archiveDetail = null;
            while (resultSet.next()) {
                archiveDetail = new Archive_Detail();
                archiveDetail.setSubAssort(resultSet.getString("FFILE_ID"));
                String visit_id = resultSet.getString("住院次数");
                archiveDetail.setMasterId(getMasterIdByPa(resultSet.getString("记账号")).getId());
                archiveDetail.setTitle(resultSet.getString("记录名称"));
                BLOB blob = (BLOB) resultSet.getBlob("文件内容");
                in = blob.getBinaryStream(); // 建立输出流
                UUID uuid = UUID.randomUUID();//UUID唯一识别
                String id = uuid.toString();
                id = id.replace("-", "");
                file = new FileOutputStream(temp + "\\" + id + ".pdf");
                int len = (int) blob.length();
                byte[] buffer = new byte[len]; // 建立缓冲区
                while ((len = in.read(buffer)) != -1) {
                    file.write(buffer, 0, len);
                }
                archiveDetail.setPdfPath(getXmlPath("path") + "\\his\\" + resultSet.getString("记账号") + "\\" + id + ".pdf");
                File file1 = new File(getXmlPath("path") + "\\his\\" + resultSet.getString("记账号"));
                if (!file1.isDirectory()) {
                    file1.mkdirs();
                }
                if (null != in) {
                    in.close();
                }
                if (null != file) {
                    file.close();
                }
                if (new File(temp + "\\" + id + ".pdf").exists()) {
                    FileUtils.copyFile(new File(temp + "\\" + id + ".pdf"), new File(archiveDetail.getPdfPath()));
                }
                archiveDetail.setAssortId("C70E8C427A3648B79BE80798C08F4D12");
                archiveDetail.setFlag("0");
                archiveDetail.setSource("his");
                archiveDetail.setUploadDateTime(new Date());
                File file2 = new File(archiveDetail.getPdfPath());
                if (file2.exists()) {
                    archiveDetail.setPdfPath(archiveDetail.getPdfPath().replace("Z:", "F:\\pdf"));
                    writeArchiveDetail(archiveDetail);
                }
                File file3 = new File(temp + "\\" + id + ".pdf");
                file3.delete();
            }
            logger.log("护理已采集，采集时间" + format + ",记账号:" + patientId);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (null != file) {
                    file.close();
                }
                if (null != in) {
                    in.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            } finally {
                JDBCUtils.release(resultSet, statement, connection);
            }
        }
    }

    public String getXmlPath(String elementName) {
        Document doc = null;
        try {
            doc = new SAXReader().read(this.getClass().getResourceAsStream("/localPath.xml"));
        } catch (DocumentException e) {
            logger.log(e.toString());
        }
        Element root = doc.getRootElement();
        Iterator itr = root.elementIterator();
        while (itr.hasNext()) {
            Element element = (Element) itr.next();
            if (elementName.equals(element.getName())) {
                return element.getTextTrim();
            }
        }
        return "";
    }

    public String getEmrAssort(String fentryNo) {
        Map<String, String> map = new HashMap<>();
        map.put("801", "DA342ED81CEE4A8EA827424626F3F521");
        map.put("804", "15E7FE7803F545CB81390BC88E725240");
        map.put("811", "C7C73CD034B440F6B33A79E382A5610F");
        map.put("828", "AFB9FBE656D7492C80AEDE6E685A851A");
        map.put("813", "7A9C621E3F4F4C9CA95292141C5E15E8");
        map.put("845R", "C7C73CD034B440F6B33A79E382A5610F");
        map.put("844", "C7C73CD034B440F6B33A79E382A5610F");
        map.put("022", "85DAE73A87D047D28C222E878C78C670");
        map.put("808", "15E7FE7803F545CB81390BC88E725240");
        map.put("803R", "AFB9FBE656D7492C80AEDE6E685A851A");
        map.put("833", "C7C73CD034B440F6B33A79E382A5610F");
        map.put("843", "C7C73CD034B440F6B33A79E382A5610F");
        map.put("846", "C7C73CD034B440F6B33A79E382A5610F");
        map.put("020", "AC2C8F4A88884DC894630302C61C6A07");
        map.put("021", "AC2C8F4A88884DC894630302C61C6A07");
        map.put("802", "AFB9FBE656D7492C80AEDE6E685A851A");
        map.put("805", "799B1580459442598B6073712736BA51");
        map.put("810", "C7C73CD034B440F6B33A79E382A5610F");
        map.put("832", "DE599D770E8347CCB5122BC357D96F35");
        map.put("814", "DE599D770E83479CB5126BC357D96F35");
        map.put("816", "DE599D770E83479CB5126BC357D96F35");
        map.put("818", "C70E8C427A3648B79BE80798C08F4D12");
        map.put("806", "7A9C621E3F4F4C9CA95292141C5E15E8");
        map.put("025", "0DB93797885746B18DAF6C0C936D2DCA");
        map.put("847", "C7C73CD034B440F6B33A79E382A5610F");
        map.put("02D", "D80ED429AEC24C389E444F3156F890B5");
        if (!StringUtils.isNoneBlank(map.get(fentryNo))) {
            return "C7C73CD034B440F6B33A79E382A5610F";
        }
        return map.get(fentryNo);
    }

    //增加病例文件信息表记录
    public int writeArchiveDetail(Archive_Detail archiveDetail) {
        String sql = "insert into archive_detail(id,PDF_PATH,MasterID,UpLoadDateTime,AssortID,Source,SubAssort,Title,flag)values(replace(newid(), '-', '')," +
                "?,?,?,?,?,?,?,?)";
        Connection connection = null;
        PreparedStatement statement = null;
        Object[] parms = new Object[]{archiveDetail.getPdfPath(), archiveDetail.getMasterId(), archiveDetail.getUploadDateTime(), archiveDetail.getAssortId(), archiveDetail.getSource(), archiveDetail.getSubAssort(), archiveDetail.getTitle(), archiveDetail.getFlag()};
        int j = 0;
        try {
            connection = JDBCUtils3.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    if (parms[i] instanceof Date) {
                        parms[i] = new java.sql.Timestamp(((Date) parms[i]).getTime());
                    }
                    statement.setObject(i + 1, parms[i]);
                }
            }
            j = statement.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            JDBCUtils.release(null, statement, connection);
        }
        return j;
    }

    public List<Dept> powerIndex() {
        String sql = "select dept_code from power_dept";
        Connection connection = null;
        PreparedStatement statement = null;
        ResultSet resultSet = null;
        List<Dept> deptList = new ArrayList<>();
        Dept dept = null;
        try {
            connection = JDBCUtils5.getConnection();
            statement = connection.prepareStatement(sql);
            resultSet = statement.executeQuery();
            while (resultSet.next()) {
                dept = new Dept();
                dept.setDeptCode(resultSet.getString("dept_code"));
                deptList.add(dept);
            }
        } catch (Exception ex) {
            logger.log(ex.toString());
        } finally {
            JDBCUtils5.release(resultSet, statement, connection);
        }
        return deptList;
    }

    public int insertPower(Dept dept) {
        int j = 0;
        Connection connection = null;
        PreparedStatement statement = null;
        String sql = "insert into power_dept(dept_name,dict_id,effective" +
                ",creater,create_date,updater,dept_code)values(?,?,?,?,?,?,?)";
        Object[] parms = new Object[]{dept.getFdeptname(), 1, 1, "admin", dept.getFlogcdate(), "admin", dept.getDeptCode()};
        try {
            connection = JDBCUtils5.getConnection();
            statement = connection.prepareStatement(sql);
            if (parms != null && parms.length > 0) {
                for (int i = 0; i < parms.length; i++) {
                    statement.setObject(i + 1, parms[i]);
                }
            }
            j = statement.executeUpdate();
        } catch (Exception e) {
            logger.log(e.toString());
        } finally {
            JDBCUtils.release(null, statement, connection);
        }
        return j;
    }
}
